#pragma once

#include "SampleGrabberCB.h"

class VideoGrabberObserver;

//=====================================================================================//
//                                 class VideoGrabber                                  //
//=====================================================================================//
class VideoGrabber : public SampleGrabberCB
{
public:

	VideoGrabberObserver& m_observer;

public:
	VideoGrabber(VideoGrabberObserver& observer);
	~VideoGrabber();
public:
	///	receives a pointer to the sample buffer
	STDMETHOD(BufferCB)(double SampleTime,BYTE *pBuffer,long BufferLen);
	/// receives a pointer to the media sample
	STDMETHOD(SampleCB)(double SampleTime,IMediaSample *pSample);

};

//=====================================================================================//
//                             class VideoGrabberObserver                              //
//=====================================================================================//
class VideoGrabberObserver
{
public:
	virtual ~VideoGrabberObserver() {}
	///	process video data callback
	virtual void onVideoData(const char* data,unsigned int size,unsigned int timestamp) = 0;

};